import java.awt.Color;

import DwarfEngine.Application;
import DwarfEngine.Debug;
import DwarfEngine.Input;
import DwarfEngine.Keycode;
import DwarfEngine.MathTypes.Vector2;
import DwarfEngine.SimpleGraphics2D.Draw2D;

@SuppressWarnings("serial")
class InputDemo extends Application {

	public void OnStart() {
		Input.init();
	}

	Color c = Color.red;
	Vector2 pos = new Vector2(30, 30);
	Vector2 size = new Vector2(20, 20);
	float x = 150;
	float y = 150;
	public void OnUpdate() {
		clear(Color.black);
		
		float speed = 100;
		if (Input.OnKeyHeld(Keycode.W)) pos.y -= deltaTime * speed;
		if (Input.OnKeyHeld(Keycode.S)) pos.y += deltaTime * speed;
		if (Input.OnKeyHeld(Keycode.A)) pos.x -= deltaTime * speed;
		if (Input.OnKeyHeld(Keycode.D)) pos.x += deltaTime * speed;
		
		
		Draw2D.FillRect(pos, size, c);
		Draw2D.FillCircle(new Vector2(x, y), 20, Color.yellow);
		x += Input.getMouseDelta().x * 10;
		y += Input.getMouseDelta().y * 10;
		//Debug.Log(Input.getMouseDelta());
		
		Vector2 mousePosition = Input.getMousePosition();
		Vector2 winWidth = new Vector2(getWidth(), getHeight());
		Vector2 imageWidth = getWindowSize();
		Vector2 delta = new Vector2(winWidth.x/imageWidth.x, winWidth.y/imageWidth.y);
		mousePosition = new Vector2(mousePosition.x/delta.x, mousePosition.y/delta.y);
		
		//Draw2D.FillCircle(mousePosition, 4, Color.magenta);
		
		if (Input.OnKeyPressed(Keycode.F1)) {
			saveImage("C:\\Users\\USER\\OneDrive\\Desktop", "Sphere");
		}
	}
}


public class InputTest {

	public static void main(String[] args) {
		InputDemo demo = new InputDemo();
		demo.SetResizable(true);
		demo.Construct(300, 300, 2);
	}

}
